/*
 * Created on 2019-08-18 ( Time 17:15:13 )
 * Generated by Telosys Tools Generator ( version 3.0.0 )
 */
// This Bean has a basic Primary Key (not composite) 

package ci.diaspora.star.motors.sarl.dao.entity;

import java.io.Serializable;

//import javax.validation.constraints.* ;
//import org.hibernate.validator.constraints.* ;

import java.util.Date;

import javax.persistence.*;

/**
 * Persistent class for entity stored in table "piece_detachee_fiche_preparation_devis"
 *
 * @author Telosys Tools Generator
 *
 */

@Entity
@Table(name="piece_detachee_fiche_preparation_devis" )
public class PieceDetacheeFichePreparationDevis implements Serializable, Cloneable {

    private static final long serialVersionUID = 1L;

    //----------------------------------------------------------------------
    // ENTITY PRIMARY KEY ( BASED ON A SINGLE FIELD )
    //----------------------------------------------------------------------
	/*
	 * 
	 */
    @Id
    @GeneratedValue(strategy=GenerationType.AUTO)
    @Column(name="id", nullable=false)
    private Integer    id           ;


    //----------------------------------------------------------------------
    // ENTITY DATA FIELDS 
    //----------------------------------------------------------------------    
	/*
	 * 
	 */
    @Column(name="quantite")
    private Integer    quantite     ;

	/*
	 * 
	 */
    @Column(name="prix_unitaire")
    private Float      prixUnitaire ;

	/*
	 * 
	 */
    @Column(name="total")
    private Float      total        ;

	/*
	 * 
	 */
    @Column(name="is_valided")
    private Boolean    isValided    ;

	/*
	 * 
	 */
    @Column(name="is_deleted")
    private Boolean    isDeleted    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="created_at")
    private Date       createdAt    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="updated_at")
    private Date       updatedAt    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="deleted_at")
    private Date       deletedAt    ;

	/*
	 * 
	 */
    @Column(name="created_by")
    private Integer    createdBy    ;

	/*
	 * 
	 */
    @Column(name="updated_by")
    private Integer    updatedBy    ;

	/*
	 * 
	 */
    @Column(name="deleted_by")
    private Integer    deletedBy    ;

	// "pieceDetacheeId" (column "piece_detachee_id") is not defined by itself because used as FK in a link 
	// "fichePreparationDevisId" (column "fiche_preparation_devis_id") is not defined by itself because used as FK in a link 
	// "fournisseurId" (column "fournisseur_id") is not defined by itself because used as FK in a link 


    //----------------------------------------------------------------------
    // ENTITY LINKS ( RELATIONSHIP )
    //----------------------------------------------------------------------
    @ManyToOne
    @JoinColumn(name="piece_detachee_id", referencedColumnName="id")
    private PieceDetachee pieceDetachee;
    @ManyToOne
    @JoinColumn(name="fournisseur_id", referencedColumnName="id")
    private Fournisseur fournisseur ;
    @ManyToOne
    @JoinColumn(name="fiche_preparation_devis_id", referencedColumnName="id")
    private FichePreparationDevis fichePreparationDevis;

    //----------------------------------------------------------------------
    // CONSTRUCTOR(S)
    //----------------------------------------------------------------------
    public PieceDetacheeFichePreparationDevis() {
		super();
    }
    
    //----------------------------------------------------------------------
    // GETTER & SETTER FOR THE KEY FIELD
    //----------------------------------------------------------------------
    public void setId( Integer id ) {
        this.id = id ;
    }
    public Integer getId() {
        return this.id;
    }

    //----------------------------------------------------------------------
    // GETTERS & SETTERS FOR FIELDS
    //----------------------------------------------------------------------
    //--- DATABASE MAPPING : quantite ( INT ) 
    public void setQuantite( Integer quantite ) {
        this.quantite = quantite;
    }
    public Integer getQuantite() {
        return this.quantite;
    }

    //--- DATABASE MAPPING : prix_unitaire ( FLOAT ) 
    public void setPrixUnitaire( Float prixUnitaire ) {
        this.prixUnitaire = prixUnitaire;
    }
    public Float getPrixUnitaire() {
        return this.prixUnitaire;
    }

    //--- DATABASE MAPPING : total ( FLOAT ) 
    public void setTotal( Float total ) {
        this.total = total;
    }
    public Float getTotal() {
        return this.total;
    }

    //--- DATABASE MAPPING : is_valided ( BIT ) 
    public void setIsValided( Boolean isValided ) {
        this.isValided = isValided;
    }
    public Boolean getIsValided() {
        return this.isValided;
    }

    //--- DATABASE MAPPING : is_deleted ( BIT ) 
    public void setIsDeleted( Boolean isDeleted ) {
        this.isDeleted = isDeleted;
    }
    public Boolean getIsDeleted() {
        return this.isDeleted;
    }

    //--- DATABASE MAPPING : created_at ( DATETIME ) 
    public void setCreatedAt( Date createdAt ) {
        this.createdAt = createdAt;
    }
    public Date getCreatedAt() {
        return this.createdAt;
    }

    //--- DATABASE MAPPING : updated_at ( DATETIME ) 
    public void setUpdatedAt( Date updatedAt ) {
        this.updatedAt = updatedAt;
    }
    public Date getUpdatedAt() {
        return this.updatedAt;
    }

    //--- DATABASE MAPPING : deleted_at ( DATETIME ) 
    public void setDeletedAt( Date deletedAt ) {
        this.deletedAt = deletedAt;
    }
    public Date getDeletedAt() {
        return this.deletedAt;
    }

    //--- DATABASE MAPPING : created_by ( INT ) 
    public void setCreatedBy( Integer createdBy ) {
        this.createdBy = createdBy;
    }
    public Integer getCreatedBy() {
        return this.createdBy;
    }

    //--- DATABASE MAPPING : updated_by ( INT ) 
    public void setUpdatedBy( Integer updatedBy ) {
        this.updatedBy = updatedBy;
    }
    public Integer getUpdatedBy() {
        return this.updatedBy;
    }

    //--- DATABASE MAPPING : deleted_by ( INT ) 
    public void setDeletedBy( Integer deletedBy ) {
        this.deletedBy = deletedBy;
    }
    public Integer getDeletedBy() {
        return this.deletedBy;
    }


    //----------------------------------------------------------------------
    // GETTERS & SETTERS FOR LINKS
    //----------------------------------------------------------------------

    public void setPieceDetachee( PieceDetachee pieceDetachee ) {
        this.pieceDetachee = pieceDetachee;
    }
    public PieceDetachee getPieceDetachee() {
        return this.pieceDetachee;
    }


    public void setFournisseur( Fournisseur fournisseur ) {
        this.fournisseur = fournisseur;
    }
    public Fournisseur getFournisseur() {
        return this.fournisseur;
    }


    public void setFichePreparationDevis( FichePreparationDevis fichePreparationDevis ) {
        this.fichePreparationDevis = fichePreparationDevis;
    }
    public FichePreparationDevis getFichePreparationDevis() {
        return this.fichePreparationDevis;
    }


    //----------------------------------------------------------------------
    // toString METHOD
    //----------------------------------------------------------------------
    public String toString() { 
        StringBuffer sb = new StringBuffer(); 
        sb.append("["); 
        sb.append(id);
        sb.append("]:"); 
        sb.append(quantite);
        sb.append("|");
        sb.append(prixUnitaire);
        sb.append("|");
        sb.append(total);
        sb.append("|");
        sb.append(isValided);
        sb.append("|");
        sb.append(isDeleted);
        sb.append("|");
        sb.append(createdAt);
        sb.append("|");
        sb.append(updatedAt);
        sb.append("|");
        sb.append(deletedAt);
        sb.append("|");
        sb.append(createdBy);
        sb.append("|");
        sb.append(updatedBy);
        sb.append("|");
        sb.append(deletedBy);
        return sb.toString(); 
    } 

	//----------------------------------------------------------------------
    // clone METHOD
    //----------------------------------------------------------------------
	@Override
	public Object clone() throws CloneNotSupportedException {
		return super.clone();
	}
}
